/*
 * Copyright (c) 1997 IBM Corporation.
 * Copyright (c) 1997 Sun Microsystems, Inc. All Rights Reserved.
 * Copyright (c) 1997 ORA, Inc. All Rights Reserved.
 * Code derived from  the original OpenCard Framework
 * 
 */

package com.ora.smartcard.terminal.reflex20;

import opencard.terminal.*;

/** <tt>CardTerminalFactory</tt> for Assorted card terminals.
  * Currently we just support the Reflex20
  *
  * @version 1.0
  *
  * @see opencard.terminal.CardTerminalFactory
  */
public class ORACardTerminalFactory implements CardTerminalFactory {
  private static boolean TRACE = Boolean.getBoolean("com.ora.smartcard.terminal.Reflex20.trace");

  public CardTerminal createCardTerminal(String name, String type,
					 String connector)
    throws ClassNotFoundException, CardTerminalException {
      Reflex20CardTerminal terminal = null;
		System.err.println("looking for:" + type );

      if (type.equals("Reflex20")) {
	terminal = new Reflex20CardTerminal(name, type, connector);
	if (TRACE)
	  System.err.println("Zurich terminal: " + terminal);
      }
      else {
	throw new ClassNotFoundException("Type unknown: " + type);
      }
      return terminal;
  }
}
