/*
 * Copyright (c) 1997 IBM Corporation.
 * Copyright (c) 1997 Sun Microsystems, Inc. All Rights Reserved.
 * Copyright (c) 1997 ORA, Inc. All Rights Reserved.
 * Code derived from  the original OpenCard Framework
 */
package com.ora.smartcard.terminal.reflex20;

/** Defines some constants used by Reflex20 terminals.
 * Some of these ar enot used and need to be deleted.
 *
 */
public interface Reflex20Constants {
  /** CT API return codes
    */
  static final int CT_OK          = 0;
  static final int CT_ERR_INVALID = -1;
  static final int CT_ERR_CT      = -8;
  static final int CT_ERR_TRANS   = -10;
  static final int CT_ERR_MEMORY  = -11;
  static final int CT_ERR_HTSI    = -128;

  /** The class byte for terminal commands
    */
  static final byte RESETCLASS    = (byte)0x20;
  static final byte TERMINAL    = (byte)0x01;
  static final byte ICC    = (byte)0x00;

  /** Terminal commands instruction bytes
    */
  static final byte RESET       = (byte)0x10;
  static final byte WRESET      = (byte)0x1F;
  static final byte RBINARY     = (byte)0xB0;
  static final byte REQUESTCARD = (byte)0x12;
  static final byte GETSTATUS   = (byte)0xA4;
  static final byte EJECTCARD   = (byte)0x15;
  static final byte READPINPAD  = (byte)0x1a;
  static final byte PINVERIFY   = (byte)0x1b;
  static final byte DISPLAY     = (byte)0x1c;
  static final byte Pone0       = (byte)0x0;
  static final byte Ptwo0       = (byte)0x0;
  static final byte PATR        = (byte)0x1;

}
