/*
 * Copyright (c) 1997 IBM Corporation.
 * Copyright (c) 1997 Sun Microsystems, Inc. All Rights Reserved.
 * Copyright (c) 1997 ORA, Inc. All Rights Reserved.
 * Code derived from  the original OpenCard Framework
 */
#undef DEBUG
#define CT_ERR_HTSI -128
#define HOST 2
#include <windows.h>
#ifndef _USE_JRI_
#include <jni.h>
extern int FAR PASCAL CT_init( unsigned int , unsigned int);
int FAR PASCAL CT_close( unsigned int );
char FAR PASCAL CT_data( unsigned int , 
	unsigned char *, 
	unsigned char *,
	unsigned int ,
	unsigned *,
	unsigned int *,
	unsigned char *);



JNIEXPORT jint JNICALL
Java_com_ora_smartcard_terminal_reflex20_Reflex20Driver_ctInit(JNIEnv *env,
								    jobject that,
								    jint ctNumber,
								    jint portNumber) {
  return (jint)CT_init((unsigned char)ctNumber, (unsigned char)portNumber);
 }

JNIEXPORT jint JNICALL
Java_com_ora_smartcard_terminal_reflex20_Reflex20Driver_ctData(JNIEnv *env,
								    jobject that,
								    jbyte destination,
								    jbyteArray command, 
								    jint commandLength,
								    jbyteArray response,
								    jint responseMax) {
  short rc;
  unsigned char sad = HOST;
  unsigned char dad = destination;
  unsigned short responseLength = (unsigned short)responseMax;
  unsigned char *commandArray;
  unsigned char *responseArray;
  jclass cls = (*env)->GetObjectClass(env, that);
  jfieldID fid;
  jint ctn;
  int i;
  
#ifdef DEBUG
	printf("Destination: %d\n", dad);
#endif
  fid = (*env)->GetFieldID(env, cls, "ctNumber", "I");
  if(fid == NULL) {
    fprintf(stderr, "could not get field ID\n");
    return(CT_ERR_HTSI);
  }
  ctn = (*env)->GetIntField(env, that, fid);
  
  commandArray = (unsigned char *) (*env)->GetByteArrayElements(env, command,
								0);
  responseArray = (unsigned char *) (*env)->GetByteArrayElements(env, response,
								 0);
#ifdef DEBUG
	printf ("Sending data  ");
  for ( i = 0; i < commandLength; i++ ) {
     printf("%02x ", commandArray[i] );
  }
#endif
  rc = CT_data(ctn, &dad, &sad,
	       commandLength, commandArray,
	       &responseLength, responseArray);

#ifdef DEBUG
	printf ("\nReturned data ");
  for ( i = 0; i < responseLength; i++ ) {
     printf("%02x ", responseArray[i] );
  }
 	printf("\n");
#endif
  (*env)->ReleaseByteArrayElements(env, command, (signed char *)commandArray,
				   0);
  (*env)->ReleaseByteArrayElements(env, response, (signed char *)responseArray,
				   0);
  
  /* This can be done better, probably! */
  fid = (*env)->GetFieldID(env, cls, "responseLength", "I");
  if(fid == NULL) {
    fprintf(stderr, "could not get field ID\n");
    return(CT_ERR_HTSI);
  }
  
  (*env)->SetIntField(env, that, fid, responseLength);
  return (jint)rc;
}

JNIEXPORT jint JNICALL
Java_com_ora_smartcard_terminal_reflex20_Reflex20Driver_ctClose(JNIEnv *env,
								     jobject that,
								     jint ctNumber) {
  return (jint)CT_close((unsigned char)ctNumber);
}
#else /* _USE_JRI_ */
/* Netscape JRI implementation of native methods for IBM 5948 card terminal */
/* We can get rid of this, once Communicator supports JNI */ 
#include <jri.h>
#include "com_ora_smartcard_terminal_reflex20_Reflex20Driver.h"


JRI_PUBLIC_API(jint)
native_com_ora_smartcard_terminal_reflex20_Reflex20Driver_ctInit(JRIEnv *env,
								      struct java_lang_Class *cl,
								      jint ctNumber,
								      jint portNumber) {
  return (jint)CT_init((unsigned char)ctNumber, (unsigned char)portNumber);
}

JRI_PUBLIC_API(jint)
native_com_ora_smartcard_terminal_reflex20_Reflex20Driver_ctData(JRIEnv *env,
								      struct com_ora_smartcard_terminal_reflex20_Reflex20Driver *that,
								      jbyte destination,
								      jbyteArray command, 
								      jint commandLength,
								      jbyteArray response,
								      jint responseMax) {
  short rc;
  unsigned char sad = HOST;
  unsigned char dad = destination;
  unsigned short responseLength = responseMax;
  unsigned char *commandArray;
  unsigned char *responseArray;
  struct java_lang_Class *cls = JRI_GetObjectClass(env, that);
  JRIFieldID fid;
  jint ctn;
  
  fid = JRI_GetFieldID(env, cls, "ctNumber", "I");
  ctn = JRI_GetFieldInt(env, that, fid);
  
  commandArray = (unsigned char *) JRI_GetScalarArrayElements(env, command);
  responseArray = (unsigned char *) JRI_GetScalarArrayElements(env, response);
  
  rc = CT_data(ctn, &dad, &sad,
	       commandLength, commandArray,
	       &responseLength, responseArray);
  
  /* This can be done better, probably! */
  fid = JRI_GetFieldID(env, cls, "responseLength", "I");
  JRI_SetFieldInt(env, that, fid, responseLength);
  return (jint)rc;
}

JRI_PUBLIC_API(jint)
native_com_ora_smartcard_terminal_reflex20_Reflex20Driver_ctClose(JRIEnv *env,
								       struct java_lang_Class *cl,
								       jint ctNumber) {
  return (jint)CT_close((unsigned char)ctNumber);
}
#endif /* _USE_JRI_ */

